searchNodes=[{"doc":"CqrsTools is a set of macros to make CQRS applications easy to manager. Bounded Contexts Creates proxy functions for commands and events . Commands Creates commands with validation, dispatch logic, and more. Events Creates events...easily Queries Define queries with filters, validation, execution, and more.","ref":"Cqrs.html","title":"Cqrs","type":"module"},{"doc":"Macros to create proxy functions to commands and queries in a module. Examples defmodule Users do use Cqrs.BoundedContext command CreateUser command CreateUser , as : :create_user2 query GetUser query GetUser , as : :get_user2 end Commands iex&gt; { :error , { :invalid_command , state } } = ...&gt; Users . create_user ( name : &quot;chris&quot; , email : &quot;wrong&quot; ) ...&gt; state . errors %{ email : [ &quot;has invalid format&quot; ] } iex&gt; { :error , { :invalid_command , state } } = ...&gt; Users . create_user2 ( name : &quot;chris&quot; , email : &quot;wrong&quot; ) ...&gt; state . errors %{ email : [ &quot;has invalid format&quot; ] } iex&gt; Users . create_user ( name : &quot;chris&quot; , email : &quot;chris@example.com&quot; ) { :ok , :dispatched } iex&gt; Users . create_user2 ( name : &quot;chris&quot; , email : &quot;chris@example.com&quot; ) { :ok , :dispatched } Queries iex&gt; Users . get_user! ( ) ** (Cqrs.Query.QueryError) %{email: [&quot;can&#39;t be blank&quot;]} iex&gt; Users . get_user2! ( ) ** (Cqrs.Query.QueryError) %{email: [&quot;can&#39;t be blank&quot;]} iex&gt; Users . get_user! ( email : &quot;wrong&quot; ) ** (Cqrs.Query.QueryError) %{email: [&quot;has invalid format&quot;]} iex&gt; { :error , %{ errors : errors } } = Users . get_user ( ) ...&gt; errors [ email : { &quot;can&#39;t be blank&quot; , [ validation : :required ] } ] iex&gt; { :error , %{ errors : errors } } = Users . get_user ( email : &quot;wrong&quot; ) ...&gt; errors [ email : { &quot;has invalid format&quot; , [ validation : :format ] } ] iex&gt; { :ok , query } = Users . get_user_query ( email : &quot;chris@example.com&quot; ) ...&gt; query # Ecto.Query &lt; from u0 in User , where : u0 . email == ^ &quot;chris@example.com&quot; &gt; iex&gt; { :ok , user } = Users . get_user ( email : &quot;chris@example.com&quot; ) ...&gt; %{ id : user . id , email : user . email } %{ id : &quot;052c1984-74c9-522f-858f-f04f1d4cc786&quot; , email : &quot;chris@example.com&quot; } Usage with Elixir.Commanded If you are a Commanded user, you have already registered your commands with your commanded routers. Instead of repeating yourself, you can cut down on boilerplate with the import_commands/1 macro. Since Commanded is an optional dependency, you need to explicitly import Cqrs.BoundedContext to bring the macro into scope. defmodule UsersEnhanced do use Cqrs.BoundedContext import Cqrs.BoundedContext import_commands CommandedRouter query GetUser query GetUser , as : :get_user2 end","ref":"Cqrs.BoundedContext.html","title":"Cqrs.BoundedContext","type":"module"},{"doc":"Creates proxy functions to dispatch this command module. Functions created When given CreateUser create_user!/0 create_user!/1 create_user!/2 create_user/0 create_user/1 create_user/2 Options :after - A function of one arity to run with the execution result.","ref":"Cqrs.BoundedContext.html#command/2","title":"Cqrs.BoundedContext.command/2","type":"macro"},{"doc":"Imports all of a Command Router's registered commands. Options :only - Restrict importing to only the commands listed :except - Imports commands except those listed :after - a list of function names and a function of one arity to run with the execution result Example import_commands Example.Users.Router , except : [ CreateUser ] , after : [ reinstate_user : &amp; AfterExecution . load_user / 1 , suspend_user : &amp; AfterExecution . load_user / 1 ]","ref":"Cqrs.BoundedContext.html#import_commands/2","title":"Cqrs.BoundedContext.import_commands/2","type":"macro"},{"doc":"Creates proxy functions to create and execute the give query. Functions created When given ListUsers list_users!/0 list_users!/1 list_users!/2 list_users/0 list_users/1 list_users/2 list_users_query!/0 list_users_query!/1 list_users_query!/2 list_users_query/0 list_users_query/1 list_users_query/2","ref":"Cqrs.BoundedContext.html#query/2","title":"Cqrs.BoundedContext.query/2","type":"macro"},{"doc":"The Command macro allows you to define a command that encapsulates a struct definition, data validation, dependency validation, and dispatching of the command. Options require_all_fields - If true , all fields will be required. Defaults to true dispatcher - A module that defines a dispatch/2 . Examples defmodule CreateUser do use Cqrs.Command field :email , :string field :name , :string field :id , :binary_id , required : false @impl true def handle_validate ( command , _opts ) do Ecto.Changeset . validate_format ( command , :email , ~r/@/ ) end @impl true def after_validate ( %{ email : email } = command ) do Map . put ( command , :id , UUID . uuid5 ( :oid , email ) ) end @impl true def handle_dispatch ( _command , _opts ) do { :ok , :dispatched } end end Creation iex&gt; CreateUser . new ( ) # CreateUser &lt; errors : %{ email : [ &quot;can&#39;t be blank&quot; ] , name : [ &quot;can&#39;t be blank&quot; ] } &gt; iex&gt; CreateUser . new ( email : &quot;chris@example.com&quot; , name : &quot;chris&quot; ) # CreateUser &lt; %{ email : &quot;chris@example.com&quot; , id : &quot;052c1984-74c9-522f-858f-f04f1d4cc786&quot; , name : &quot;chris&quot; } &gt; iex&gt; %{ id : &quot;052c1984-74c9-522f-858f-f04f1d4cc786&quot; } = CreateUser . new! ( email : &quot;chris@example.com&quot; , name : &quot;chris&quot; ) Dispatching iex&gt; { :error , { :invalid_command , state } } = ...&gt; CreateUser . new ( name : &quot;chris&quot; , email : &quot;wrong&quot; ) ...&gt; |&gt; CreateUser . dispatch ( ) ...&gt; state . errors %{ email : [ &quot;has invalid format&quot; ] } iex&gt; CreateUser . new ( name : &quot;chris&quot; , email : &quot;chris@example.com&quot; ) ...&gt; |&gt; CreateUser . dispatch ( ) { :ok , :dispatched } Event derivation You can derive events directly from a command. see derive_event/2 defmodule DeactivateUser do use Cqrs.Command field :id , :binary_id derive_event UserDeactivated end Usage with Commanded defmodule Commanded.Application do use Commanded.Application , otp_app : :my_app , default_dispatch_opts : [ consistency : :strong , returning : :execution_result ] , event_store : [ adapter : Commanded.EventStore.Adapters.EventStore , event_store : MyApp.EventStore ] end defmodule DeactivateUser do use Cqrs.Command , dispatcher : Commanded.Application field :id , :binary_id derive_event UserDeactivated end iex&gt; { :ok , event } = DeactivateUser . new ( id : &quot;052c1984-74c9-522f-858f-f04f1d4cc786&quot; ) ...&gt; |&gt; DeactivateUser . dispatch ( ) ...&gt; %{ id : event . id , version : event . version } %{ id : &quot;052c1984-74c9-522f-858f-f04f1d4cc786&quot; , version : 1 }","ref":"Cqrs.Command.html","title":"Cqrs.Command","type":"behaviour"},{"doc":"Allows one to modify the fully validated command. The changes to the command are validated again after this callback. This callback is optional. Invoked after the handle_validate/2 callback is called.","ref":"Cqrs.Command.html#c:after_validate/1","title":"Cqrs.Command.after_validate/1","type":"callback"},{"doc":"This callback is intended to be used as a last chance to do any validation that performs IO. This callback is optional. Invoked before handle_dispatch/2 .","ref":"Cqrs.Command.html#c:before_dispatch/2","title":"Cqrs.Command.before_dispatch/2","type":"callback"},{"doc":"Generates a Elixir.Cqrs.DomainEvent based on the fields defined in the Elixir.Cqrs.Command . Accepts all the options that Elixir.Cqrs.DomainEvent accepts.","ref":"Cqrs.Command.html#derive_event/2","title":"Cqrs.Command.derive_event/2","type":"macro"},{"doc":"Defines a command field. :name - any atom :type - any valid Ecto.Schema type :opts - any valid Ecto.Schema field options. Plus: :required - true | false . Defaults to the require_all_fields option. :description - Documentation for the field.","ref":"Cqrs.Command.html#field/3","title":"Cqrs.Command.field/3","type":"macro"},{"doc":"This callback is intended to be used to run the fully validated command. This callback is required.","ref":"Cqrs.Command.html#c:handle_dispatch/2","title":"Cqrs.Command.handle_dispatch/2","type":"callback"},{"doc":"Allows one to define any custom data validation aside from casting and requiring fields. This callback is optional. Invoked when the new() or new!() function is called.","ref":"Cqrs.Command.html#c:handle_validate/2","title":"Cqrs.Command.handle_validate/2","type":"callback"},{"doc":"","ref":"Cqrs.Command.html#t:command/0","title":"Cqrs.Command.command/0","type":"type"},{"doc":"Defines validation functions for a validated command.","ref":"Cqrs.CommandValidation.html","title":"Cqrs.CommandValidation","type":"module"},{"doc":"Adds a validation_function to the list of validations to run.","ref":"Cqrs.CommandValidation.html#add/2","title":"Cqrs.CommandValidation.add/2","type":"function"},{"doc":"Creates a new Cqrs.CommandValidation struct.","ref":"Cqrs.CommandValidation.html#new/1","title":"Cqrs.CommandValidation.new/1","type":"function"},{"doc":"Runs the list of 'validation_function' functions","ref":"Cqrs.CommandValidation.html#run/2","title":"Cqrs.CommandValidation.run/2","type":"function"},{"doc":"","ref":"Cqrs.CommandValidation.html#t:command/0","title":"Cqrs.CommandValidation.command/0","type":"type"},{"doc":"","ref":"Cqrs.CommandValidation.html#t:t/0","title":"Cqrs.CommandValidation.t/0","type":"type"},{"doc":"","ref":"Cqrs.CommandValidation.html#t:validation_function/0","title":"Cqrs.CommandValidation.validation_function/0","type":"type"},{"doc":"Defines a new domain event struct Options :from optional - a struct to derive fields from. :with optional - a list of atom field names to add. :drop optional - a list of atom field names to remove from any field derived from the struct in the :from option. :version optional - a version value. Defaults to 1 Example defmodule DeleteUser do use Cqrs.Command field :id , :integer def handle_dispatch ( command , _opts ) do { :ok , :no_impl } end end defmodule UserDeleted do use Cqrs.DomainEvent , from : DeleteUser , with : [ :from ] , version : 2 end iex&gt; cmd = DeleteUser . new! ( id : 668 ) ...&gt; event = UserDeleted . new ( cmd , from : &quot;chris&quot; ) ...&gt; %{ id : event . id , from : event . from , version : event . version } %{ id : 668 , from : &quot;chris&quot; , version : 2 }","ref":"Cqrs.DomainEvent.html","title":"Cqrs.DomainEvent","type":"module"},{"doc":"Defines a query and any filters. Options require_all_filters - If true , all filters will be required. Defaults to false Examples defmodule GetUser do use Cqrs.Query alias Cqrs.QueryTest.User filter :email , :string , required : true @impl true def handle_validate ( filters , _opts ) do Ecto.Changeset . validate_format ( filters , :email , ~r/@/ ) end @impl true def handle_create ( [ email : email ] , _opts ) do from u in User , where : u . email == ^ email end @impl true def handle_execute ( query , opts ) do { :ok , Repo . all ( query , opts ) } end end Creation iex&gt; GetUser . new! ( ) ** (Cqrs.Query.QueryError) %{email: [&quot;can&#39;t be blank&quot;]} iex&gt; GetUser . new! ( email : &quot;wrong&quot; ) ** (Cqrs.Query.QueryError) %{email: [&quot;has invalid format&quot;]} iex&gt; { :error , %{ errors : errors } } = GetUser . new ( ) ...&gt; errors [ email : { &quot;can&#39;t be blank&quot; , [ validation : :required ] } ] iex&gt; { :error , %{ errors : errors } } = GetUser . new ( email : &quot;wrong&quot; ) ...&gt; errors [ email : { &quot;has invalid format&quot; , [ validation : :format ] } ] iex&gt; { :ok , query } = GetUser . new ( email : &quot;chris@example.com&quot; ) ...&gt; query # Ecto.Query &lt; from u0 in User , where : u0 . email == ^ &quot;chris@example.com&quot; &gt; Execution iex&gt; { :ok , user } = ...&gt; GetUser . new ( email : &quot;chris@example.com&quot; ) ...&gt; |&gt; GetUser . execute ( ) ...&gt; %{ id : user . id , email : user . email } %{ id : &quot;052c1984-74c9-522f-858f-f04f1d4cc786&quot; , email : &quot;chris@example.com&quot; }","ref":"Cqrs.Query.html","title":"Cqrs.Query","type":"behaviour"},{"doc":"","ref":"Cqrs.Query.html#execute/3","title":"Cqrs.Query.execute/3","type":"function"},{"doc":"Defines a Elixir.Cqrs.Query filter. :name - any atom :type - any valid Ecto.Schema type :opts - any valid Ecto.Schema field options. Plus: :required - true | false . Defaults to the require_all_fields option. :description - Documentation for the field.","ref":"Cqrs.Query.html#filter/3","title":"Cqrs.Query.filter/3","type":"macro"},{"doc":"","ref":"Cqrs.Query.html#c:handle_create/2","title":"Cqrs.Query.handle_create/2","type":"callback"},{"doc":"","ref":"Cqrs.Query.html#c:handle_execute/2","title":"Cqrs.Query.handle_execute/2","type":"callback"},{"doc":"","ref":"Cqrs.Query.html#c:handle_validate/2","title":"Cqrs.Query.handle_validate/2","type":"callback"},{"doc":"","ref":"Cqrs.Query.html#t:filters/0","title":"Cqrs.Query.filters/0","type":"type"},{"doc":"","ref":"Cqrs.Query.html#t:opts/0","title":"Cqrs.Query.opts/0","type":"type"},{"doc":"","ref":"Cqrs.Query.html#t:query/0","title":"Cqrs.Query.query/0","type":"type"},{"doc":"","ref":"Cqrs.BoundedContext.InvalidCommandError.html","title":"Cqrs.BoundedContext.InvalidCommandError","type":"exception"},{"doc":"Callback implementation for Exception.message/1 .","ref":"Cqrs.BoundedContext.InvalidCommandError.html#message/1","title":"Cqrs.BoundedContext.InvalidCommandError.message/1","type":"function"},{"doc":"","ref":"Cqrs.BoundedContext.InvalidQueryError.html","title":"Cqrs.BoundedContext.InvalidQueryError","type":"exception"},{"doc":"Callback implementation for Exception.message/1 .","ref":"Cqrs.BoundedContext.InvalidQueryError.html#message/1","title":"Cqrs.BoundedContext.InvalidQueryError.message/1","type":"function"},{"doc":"","ref":"Cqrs.Command.CommandError.html","title":"Cqrs.Command.CommandError","type":"exception"},{"doc":"Callback implementation for Exception.message/1 .","ref":"Cqrs.Command.CommandError.html#message/1","title":"Cqrs.Command.CommandError.message/1","type":"function"},{"doc":"","ref":"Cqrs.Query.QueryError.html","title":"Cqrs.Query.QueryError","type":"exception"},{"doc":"Callback implementation for Exception.message/1 .","ref":"Cqrs.Query.QueryError.html#message/1","title":"Cqrs.Query.QueryError.message/1","type":"function"}]